<script setup lang="ts">
import {
  computed,
  nextTick,
  onBeforeMount,
  onMounted,
  reactive,
  ref,
} from "vue";
import type {
  UserOut,
  WorkflowExecutionOut,
  WorkflowOut,
  WorkflowVersionOut,
} from "@/client/types.gen";
import { WorkflowExecutionStatus } from "@/client/types.gen";
import SearchUserModal from "@/components/modals/SearchUserModal.vue";
import SearchWorkflowModal from "@/components/modals/SearchWorkflowVersionModal.vue";
import { useWorkflowExecutionStore } from "@/stores/workflowExecutions";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import { useNameStore } from "@/stores/names";
import dayjs from "dayjs";
import ParameterModal from "@/components/workflows/modals/ParameterModal.vue";
import MarkdownRenderer from "@/components/MarkdownRenderer.vue";
import DeleteExecutionModal from "@/components/workflows/modals/DeleteExecutionModal.vue";
import { useRoute, useRouter } from "vue-router";
import { useUserStore } from "@/stores";

const executionRepository = useWorkflowExecutionStore();
const nameRepository = useNameStore();
const userRepository = useUserStore();

const route = useRoute<"admin-executions">();
const router = useRouter();

const statusToColorMapping = {
  PENDING: "bg-warning",
  SCHEDULED: "bg-warning",
  RUNNING: "bg-info",
  CANCELED: "bg-danger",
  SUCCESS: "bg-success",
  ERROR: "bg-danger",
};

const QUERY_PARAM_EXECUTOR_ID = "executor_id";
const QUERY_PARAM_EXECUTION_STATUS = "status";
const QUERY_PARAM_VERSION_ID = "version_id";
const QUERY_PARAM_START_AFTER = "start_after";
const QUERY_PARAM_START_BEFORE = "start_before";
const QUERY_PARAM_SORT = "sort";
const QUERY_PARAM_WORKFLOW_ID = "workflow_id";

let loadingObserver: IntersectionObserver;
const endOfTableElement = ref<HTMLTableCaptionElement | undefined>(undefined);

const filters = reactive<{
  executorId?: string;
  executionStatus: WorkflowExecutionStatus[];
  workflowVersionId?: string;
  startAfter?: number;
  startBefore?: number;
  sort: "asc" | "desc";
  workflowId?: string;
}>({
  executorId: undefined,
  executionStatus: [],
  workflowVersionId: undefined,
  startAfter: undefined,
  startBefore: undefined,
  sort: "desc",
  workflowId: undefined,
});

const formState = reactive<{
  loading: boolean;
  executions: WorkflowExecutionOut[];
  executionParameters?: string;
  deleteExecution?: WorkflowExecutionOut;
}>({
  loading: false,
  executions: [],
  executionParameters: undefined,
  deleteExecution: undefined,
});

const executionIterator = ref<
  AsyncGenerator<WorkflowExecutionOut[], void, never> | undefined
>(undefined);

const workflowVersionName = computed<string>(() => {
  if (filters.workflowId != undefined) {
    let name = nameRepository.getName(filters.workflowId) ?? "";
    if (filters.workflowVersionId != undefined) {
      name = name + `@${nameRepository.getName(filters.workflowVersionId)}`;
    }
    return name;
  }
  return "";
});

function updateUser(user: UserOut) {
  filters.executorId = user.uid;
}

function updateWorkflow(
  workflow: WorkflowOut,
  workflowVersion?: WorkflowVersionOut,
) {
  filters.workflowVersionId = workflowVersion?.workflow_version_id;
  filters.workflowId = workflow.workflow_id;
}

function searchExecution() {
  loadingObserver?.disconnect();
  formState.loading = true;
  formState.executions = [];
  executionIterator.value = executionRepository.fetchExecutionsRaw(
    filters.executorId,
    filters.executionStatus.length > 0 ? filters.executionStatus : undefined,
    filters.workflowVersionId,
    filters.workflowVersionId == undefined ? filters.workflowId : undefined,
    filters.startAfter,
    filters.startBefore,
    30,
    filters.sort,
  );
  loadNextExecutions();
  const queryParams: Record<string, string | string[]> = {};
  if (filters.workflowVersionId != undefined) {
    queryParams[QUERY_PARAM_VERSION_ID] = filters.workflowVersionId;
  }
  if (filters.executionStatus.length > 0) {
    queryParams[QUERY_PARAM_EXECUTION_STATUS] = filters.executionStatus;
  }
  queryParams[QUERY_PARAM_SORT] = filters.sort;
  if (filters.executorId != undefined) {
    queryParams[QUERY_PARAM_EXECUTOR_ID] = filters.executorId;
  }
  if (filters.startAfter != undefined) {
    queryParams[QUERY_PARAM_START_AFTER] = filters.startAfter.toString();
  }
  if (filters.startBefore != undefined) {
    queryParams[QUERY_PARAM_START_BEFORE] = filters.startBefore.toString();
  }
  if (filters.workflowId != undefined) {
    queryParams[QUERY_PARAM_WORKFLOW_ID] = filters.workflowId;
  }
  router.replace({ name: "admin-executions", query: queryParams });
}

function loadNextExecutions() {
  formState.loading = true;
  executionIterator.value
    ?.next()
    .then((executions) => {
      if (executions.done ?? false) {
        return;
      }
      formState.executions.push(...executions.value);
      nextTick(() => {
        if (endOfTableElement.value != undefined) {
          loadingObserver.observe(endOfTableElement.value);
        }
      });
    })
    .finally(() => {
      formState.loading = false;
    });
}

function cancelWorkflowExecution(executionId: string) {
  executionRepository.cancelExecution(executionId).then(() => {
    const index = formState.executions.findIndex(
      (execution) => execution.execution_id === executionId,
    );
    if (index > -1) {
      formState.executions[index].status = WorkflowExecutionStatus.CANCELED;
      formState.executions[index].end_time = dayjs().unix();
    }
  });
}

function workflowExecutionCancelable(execution: WorkflowExecutionOut): boolean {
  return execution.end_time == undefined;
}

function deleteExecution(executionId: string) {
  executionRepository
    .deleteExecution(executionId)
    .then(() => {
      formState.executions = formState.executions.filter(
        (execution) => execution.execution_id !== executionId,
      );
    })
    .finally(() => {
      formState.deleteExecution = undefined;
    });
}

function startBeforeTimestampChanged(target?: HTMLInputElement | null) {
  filters.startBefore = target?.value ? dayjs(target?.value).unix() : undefined;
}

function startAfterTimestampChanged(target?: HTMLInputElement | null) {
  filters.startAfter = target?.value ? dayjs(target?.value).unix() : undefined;
}

function resetForm() {
  loadingObserver.disconnect();
  filters.executorId = undefined;
  filters.executorId = undefined;
  filters.executionStatus = [];
  filters.workflowVersionId = undefined;
  filters.workflowId = undefined;
  filters.startAfter = undefined;
  filters.startBefore = undefined;
  filters.sort = "desc";
  executionIterator.value = undefined;
  formState.executions = [];
  router.replace({ name: "admin-executions" });
}

onBeforeMount(() => {
  let search = false;
  if (route.query[QUERY_PARAM_EXECUTOR_ID] != undefined) {
    if (typeof route.query[QUERY_PARAM_EXECUTOR_ID] === "string") {
      filters.executorId = route.query[QUERY_PARAM_EXECUTOR_ID];
      userRepository.fetchUsernames([route.query[QUERY_PARAM_EXECUTOR_ID]]);
      search = true;
    }
  }
  if (route.query[QUERY_PARAM_VERSION_ID] != undefined) {
    if (typeof route.query[QUERY_PARAM_VERSION_ID] === "string") {
      filters.workflowVersionId = route.query[QUERY_PARAM_VERSION_ID];
      search = true;
    }
  }
  if (route.query[QUERY_PARAM_WORKFLOW_ID] != undefined) {
    if (typeof route.query[QUERY_PARAM_WORKFLOW_ID] === "string") {
      filters.workflowId = route.query[QUERY_PARAM_WORKFLOW_ID];
      search = true;
    }
  }
  if (route.query[QUERY_PARAM_START_AFTER] != undefined) {
    if (typeof route.query[QUERY_PARAM_START_AFTER] === "string") {
      const startAfter = Number(route.query[QUERY_PARAM_START_AFTER]);
      if (!isNaN(startAfter)) {
        filters.startAfter = startAfter;
        search = true;
      }
    }
  }
  if (route.query[QUERY_PARAM_START_BEFORE] != undefined) {
    if (typeof route.query[QUERY_PARAM_START_BEFORE] === "string") {
      const startBefore = Number(route.query[QUERY_PARAM_START_BEFORE]);
      if (!isNaN(startBefore)) {
        filters.startBefore = startBefore;
        search = true;
      }
    }
  }
  if (route.query[QUERY_PARAM_EXECUTION_STATUS] != undefined) {
    if (typeof route.query[QUERY_PARAM_EXECUTION_STATUS] === "string") {
      filters.executionStatus = [
        route.query[QUERY_PARAM_EXECUTION_STATUS] as WorkflowExecutionStatus,
      ];
    } else {
      filters.executionStatus = route.query[
        QUERY_PARAM_EXECUTION_STATUS
      ].filter((val) => val != undefined).map(
        (val) => val as WorkflowExecutionStatus,
      );
    }
    search = filters.executionStatus.length > 0 || search;
  }
  if (route.query[QUERY_PARAM_SORT] != undefined) {
    if (
      typeof route.query[QUERY_PARAM_SORT] === "string" &&
      (route.query[QUERY_PARAM_SORT] === "asc" ||
        route.query[QUERY_PARAM_SORT] === "desc")
    ) {
      filters.sort = route.query[QUERY_PARAM_SORT];
      search = true;
    }
  }
  if (search) {
    searchExecution();
  }
});

onMounted(() => {
  loadingObserver = new IntersectionObserver(
    (entries) => {
      if (entries.length > 0 && entries[0].isIntersecting) {
        loadingObserver.unobserve(entries[0].target);
        loadNextExecutions();
      }
    },
    {
      threshold: 0,
      rootMargin: "0px 0px 150px 0px",
    },
  );
});
</script>

<template>
  <delete-execution-modal
    modal-id="delete-execution-modal"
    :execution="formState.deleteExecution"
    @confirm-delete="deleteExecution"
  />
  <search-user-modal
    modal-id="admin-execution-search-user-modal"
    @user-found="updateUser"
  />
  <search-workflow-modal
    modal-id="admin-execution-search-workflow-modal"
    allow-select-workflow
    @workflow-found="updateWorkflow"
  />
  <parameter-modal
    modal-id="workflowExecutionParameterModal"
    :execution-id="formState.executionParameters"
  />
  <div class="border-bottom mb-4">
    <h2>Search Workflow Execution</h2>
  </div>
  <form
    id="admin-execution-search-form"
    @submit.prevent="searchExecution"
    @reset.prevent="resetForm"
  >
    <div
      class="d-flex justify-content-evenly align-content-center mb-4 column-gap-2 flex-wrap"
    >
      <div>
        <label for="admin-execution-state-select" class="form-label"
          >Status of Workflow Execution</label
        >
        <select
          id="admin-execution-state-select"
          v-model="filters.executionStatus"
          multiple
          class="form-select"
        >
          <option
            v-for="state in Object.values(WorkflowExecutionStatus)"
            :key="state"
          >
            {{ state }}
          </option>
        </select>
        <div class="form-label mb-0 mt-1">Sort:</div>
        <div class="form-check form-check-inline">
          <input
            id="sort-radio-asc"
            v-model="filters.sort"
            class="form-check-input"
            type="radio"
            name="sort-radio"
            value="asc"
          />
          <label class="form-check-label" for="sort-radio-asc"> Asc </label>
        </div>
        <div class="form-check form-check-inline">
          <input
            id="sort-radio-desc"
            v-model="filters.sort"
            class="form-check-input"
            type="radio"
            name="sort-radio"
            value="desc"
          />
          <label class="form-check-label" for="sort-radio-desc"> Desc </label>
        </div>
      </div>
      <div class="flex-fill">
        <label for="admin-execution-start-after-search" class="form-label"
          >Start after</label
        >
        <div class="input-group mb-2">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-hourglass-start" />
          </div>
          <input
            id="admin-execution-start-after-search"
            class="form-control"
            type="datetime-local"
            :max="dayjs().format('YYYY-MM-DDTHH:mm')"
            :value="
              filters.startAfter
                ? dayjs.unix(filters.startAfter).format('YYYY-MM-DDTHH:mm')
                : undefined
            "
            @input="
              (event) =>
                startAfterTimestampChanged(event.target as HTMLInputElement)
            "
          />
        </div>
        <label for="admin-execution-start-before-search" class="form-label"
          >Start before</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-hourglass-end" />
          </div>
          <input
            id="admin-execution-start-before-search"
            class="form-control"
            type="datetime-local"
            :max="dayjs().format('YYYY-MM-DDTHH:mm')"
            :value="
              filters.startBefore
                ? dayjs.unix(filters.startBefore).format('YYYY-MM-DDTHH:mm')
                : undefined
            "
            @input="
              (event) =>
                startBeforeTimestampChanged(event.target as HTMLInputElement)
            "
          />
        </div>
      </div>
      <div class="flex-fill">
        <label for="admin-execution-user-search" class="form-label"
          >Name of the owner</label
        >
        <div class="input-group mb-2">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-user" />
          </div>
          <input
            id="admin-execution-user-search"
            type="text"
            class="form-control"
            readonly
            :value="nameRepository.getName(filters.executorId)"
            placeholder="Search for owner"
            data-bs-toggle="modal"
            data-bs-target="#admin-execution-search-user-modal"
          />
        </div>
        <label for="admin-execution-workflow-search" class="form-label"
          >Workflow (Version)</label
        >
        <div class="input-group">
          <div class="input-group-text">
            <font-awesome-icon icon="fa-solid fa-tag" />
          </div>
          <input
            id="admin-execution-workflow-search"
            type="text"
            class="form-control"
            readonly
            :value="workflowVersionName"
            placeholder="Search for workflow (version)"
            data-bs-toggle="modal"
            data-bs-target="#admin-execution-search-workflow-modal"
          />
        </div>
      </div>
    </div>
    <button
      type="submit"
      class="btn btn-primary w-fit"
      :disabled="formState.loading"
    >
      Search
    </button>
    <button
      type="reset"
      class="btn-primary btn w-fit ms-4"
      :disabled="formState.loading"
    >
      Clear
    </button>
  </form>
  <div class="overflow-x-auto" style="max-width: 100vw">
    <table ref="executionTable" class="table table-hover align-middle">
      <caption ref="endOfTableElement">
        Displaying
        {{
          formState.executions.length
        }}
        Workflow Execution
      </caption>
      <thead>
        <tr>
          <th scope="col">Workflow</th>
          <th scope="col">Execution ID</th>
          <th scope="col">Status</th>
          <th scope="col">Started</th>
          <th scope="col">Duration</th>
          <th scope="col">Ended</th>
          <th scope="col">CPU hours [HH:mm:ss]</th>
          <th scope="col">User</th>
          <th scope="col"></th>
        </tr>
      </thead>
      <tbody>
        <template v-if="formState.executions.length > 0">
          <tr
            v-for="execution in formState.executions"
            :id="`admin-execution-${execution.execution_id}`"
            :key="execution.execution_id"
          >
            <td>
              <router-link
                v-if="execution.workflow_id && execution.workflow_version_id"
                :to="{
                  name: 'workflow-version',
                  params: {
                    versionId: execution.workflow_version_id,
                    workflowId: execution.workflow_id,
                  },
                }"
              >
                {{ nameRepository.getName(execution.workflow_id) }}@{{
                  nameRepository.getName(execution.workflow_version_id)
                }}
              </router-link>
              <markdown-renderer
                v-else-if="execution.notes"
                class="execution-notes"
                :markdown="execution.notes"
              />
              <span v-else>Deleted Workflow</span>
            </td>
            <td>
              {{ execution.execution_id }}
            </td>
            <td>
              <span
                class="rounded-pill py-1 px-2 text-light"
                :class="statusToColorMapping[execution.status]"
              >
                {{ execution.status }}</span
              >
            </td>
            <td>
              {{
                dayjs.unix(execution.start_time).format("MMM DD, YYYY HH:mm")
              }}
            </td>
            <td>
              <template v-if="execution.end_time">
                {{
                  dayjs
                    .duration(
                      execution.end_time - execution.start_time,
                      "seconds",
                    )
                    .humanize()
                }}
              </template>
              <template v-else>
                {{ dayjs.unix(execution.start_time).toNow(true) }}
              </template>
            </td>
            <td>
              <template v-if="execution.end_time">
                {{
                  dayjs.unix(execution.end_time).format("MMM DD, YYYY HH:mm")
                }}
              </template>
              <template v-else> -</template>
            </td>
            <td class="text-center">
              {{ Math.floor(dayjs.duration(execution.cpu_time).asHours()) }}:{{
                dayjs.duration(execution.cpu_time).format("mm:ss")
              }}
            </td>
            <td>
              {{ nameRepository.getName(execution.executor_id) }}
            </td>
            <td class="text-end">
              <div
                class="btn-group btn-group-sm dropdown-center dropdown-menu-start"
              >
                <button type="button" class="btn btn-secondary" disabled>
                  Details
                </button>
                <button
                  type="button"
                  class="btn btn-secondary dropdown-toggle dropdown-toggle-split"
                  data-bs-toggle="dropdown"
                  aria-expanded="false"
                >
                  <span class="visually-hidden">Toggle Dropdown</span>
                </button>
                <ul class="dropdown-menu dropdown-menu">
                  <li>
                    <button
                      class="dropdown-item align-middle"
                      type="button"
                      data-bs-toggle="modal"
                      data-bs-target="#workflowExecutionParameterModal"
                      @click="
                        formState.executionParameters = execution.execution_id
                      "
                    >
                      <span class="ms-1">Parameters</span>
                    </button>
                  </li>
                  <li v-if="workflowExecutionCancelable(execution)">
                    <button
                      class="dropdown-item text-danger align-middle"
                      type="button"
                      @click="cancelWorkflowExecution(execution.execution_id)"
                    >
                      <font-awesome-icon icon="fa-solid fa-ban" />
                      <span class="ms-1">Cancel</span>
                    </button>
                  </li>
                  <li v-if="!workflowExecutionCancelable(execution)">
                    <button
                      class="dropdown-item text-danger align-middle"
                      type="button"
                      data-bs-toggle="modal"
                      data-bs-target="#delete-execution-modal"
                      @click="formState.deleteExecution = execution"
                    >
                      <font-awesome-icon icon="fa-solid fa-trash" />
                      <span class="ms-1">Delete</span>
                    </button>
                  </li>
                </ul>
              </div>
            </td>
          </tr>
        </template>
        <tr v-else-if="!formState.loading">
          <td colspan="9" class="text-center"><i>No workflow executions</i></td>
        </tr>
        <tr v-if="formState.loading">
          <td colspan="9" class="text-center">
            <div
              class="spinner-border text-secondary spinner-border-sm"
              role="status"
            >
              <span class="visually-hidden">Loading...</span>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<style scoped></style>
